



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>BASE64,MD5,SHA,HMAC加密與解密算法(java)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">BASE64,MD5,SHA,HMAC加密與解密算法(java)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-13 11:04:15 </span>
						</div>
										<div class="post-content">
											
		<div>
<pre class="prettyprint linenums">package com.ice.webos.util.security;

import java.io.UnsupportedEncodingException;<br />
import java.math.BigInteger;<br />
import java.security.Key;<br />
import java.security.MessageDigest;<br />
import java.security.SecureRandom;

import javax.crypto.Cipher;<br />
import javax.crypto.KeyGenerator;<br />
import javax.crypto.Mac;<br />
import javax.crypto.SecretKey;<br />
import javax.crypto.SecretKeyFactory;<br />
import javax.crypto.spec.DESKeySpec;<br />
import javax.crypto.spec.SecretKeySpec;

import sun.misc.BASE64Decoder;<br />
import sun.misc.BASE64Encoder;

/**<br />
* &lt;ul&gt;<br />
* &lt;li&gt;BASE64的加密解密是双向的，可以求反解。&lt;/li&gt;<br />
* &lt;li&gt;MD5、SHA以及HMAC是单向加密，任何数据加密后只会产生唯一的一个加密串，通常用来校验数据在传输过程中是否被修改。&lt;/li&gt;<br />
* &lt;li&gt;HMAC算法有一个密钥，增强了数据传输过程中的安全性，强化了算法外的不可控因素。&lt;/li&gt;<br />
* &lt;li&gt;DES DES-Data Encryption Standard,即数据加密算法。<br />
* DES算法的入口参数有三个:Key、Data、Mode。<br />
* &lt;ul&gt;<br />
* &lt;li&gt;Key:8个字节共64位,是DES算法的工作密钥;&lt;/li&gt;<br />
* &lt;li&gt;Data:8个字节64位,是要被加密或被解密的数据;&lt;/li&gt;<br />
* &lt;li&gt;Mode:DES的工作方式,有两种:加密或解密。&lt;/li&gt;<br />
* &lt;/ul&gt;<br />
* &lt;/li&gt;<br />
* &lt;ul&gt;<br />
*<br />
* @author Ice_Liu<br />
*<br />
*/<br />
public class CryptUtil {<br />
private static final String KEY_MD5 = "MD5";<br />
private static final String KEY_SHA = "SHA";<br />
/**<br />
* MAC算法可选以下多种算法<br />
*<br />
* &lt;pre&gt;<br />
*<br />
* HmacMD5<br />
* HmacSHA1<br />
* HmacSHA256<br />
* HmacSHA384<br />
* HmacSHA512<br />
* &lt;/pre&gt;<br />
*/<br />
public static final String KEY_MAC = "HmacMD5";

/**<br />
* BASE64解密<br />
*<br />
* @param key<br />
* @return<br />
* @throws Exception<br />
*/<br />
public static byte[] decryptBASE64(String key) throws Exception {<br />
return (new BASE64Decoder()).decodeBuffer(key);<br />
}

/**<br />
* BASE64 加密<br />
*<br />
* @param key<br />
* @return<br />
* @throws Exception<br />
*/<br />
public static String encryptBASE64(byte[] key) throws Exception {<br />
return (new BASE64Encoder()).encodeBuffer(key);<br />
}

/**<br />
* MD5加密<br />
*<br />
* @param data<br />
* @return<br />
* @throws Exception<br />
*/<br />
public static byte[] encryptMD5(byte[] data) throws Exception {

MessageDigest md5 = MessageDigest.getInstance(KEY_MD5);<br />
md5.update(data);

return md5.digest();

}

/**<br />
* SHA加密<br />
*<br />
* @param data<br />
* @return<br />
* @throws Exception<br />
*/<br />
public static byte[] encryptSHA(byte[] data) throws Exception {

MessageDigest sha = MessageDigest.getInstance(KEY_SHA);<br />
sha.update(data);

return sha.digest();

}

/**<br />
* 初始化HMAC密钥<br />
*<br />
* @return<br />
* @throws Exception<br />
*/<br />
public static String initMacKey() throws Exception {<br />
KeyGenerator keyGenerator = KeyGenerator.getInstance(KEY_MAC);<br />
SecretKey secretKey = keyGenerator.generateKey();<br />
return encryptBASE64(secretKey.getEncoded());<br />
}

/**<br />
* HMAC 加密<br />
*<br />
* @param data<br />
* @param key<br />
* @return<br />
* @throws Exception<br />
*/<br />
public static byte[] encryptHMAC(byte[] data, String key) throws Exception {<br />
SecretKey secretKey = new SecretKeySpec(decryptBASE64(key), KEY_MAC);<br />
Mac mac = Mac.getInstance(secretKey.getAlgorithm());<br />
mac.init(secretKey);<br />
return mac.doFinal(data);<br />
}

/**<br />
* DES 算法 &lt;br&gt;<br />
* 可替换为以下任意一种算法，同时key值的size相应改变。<br />
*<br />
* &lt;pre&gt;<br />
* DES key size must be equal to 56<br />
* DESede(TripleDES) key size must be equal to 112 or 168<br />
* AES key size must be equal to 128, 192 or 256,but 192 and 256 bits may not be available<br />
* Blowfish key size must be multiple of 8, and can only range from 32 to 448 (inclusive)<br />
* RC2 key size must be between 40 and 1024 bits<br />
* RC4(ARCFOUR) key size must be between 40 and 1024 bits<br />
* &lt;/pre&gt;<br />
*/<br />
public static final String ALGORITHM = "DES";

/**<br />
* DES 算法转换密钥&lt;br&gt;<br />
*<br />
* @param key<br />
* @return<br />
* @throws Exception<br />
*/<br />
private static Key toKey(byte[] key) throws Exception {<br />
SecretKey secretKey = null;<br />
if (ALGORITHM.equals("DES") || ALGORITHM.equals("DESede")) {<br />
DESKeySpec dks = new DESKeySpec(key);<br />
SecretKeyFactory keyFactory = SecretKeyFactory.getInstance(ALGORITHM);<br />
secretKey = keyFactory.generateSecret(dks);<br />
} else {<br />
// 当使用其他对称加密算法时，如AES、Blowfish等算法时，用下述代码替换上述三行代码<br />
secretKey = new SecretKeySpec(key, ALGORITHM);<br />
}<br />
return secretKey;<br />
}

/**<br />
* DES 算法解密<br />
*<br />
* @param data<br />
* @param key<br />
* @return<br />
* @throws Exception<br />
*/<br />
public static byte[] decrypt(byte[] data, String key) throws Exception {<br />
Key k = toKey(decryptBASE64(key));<br />
Cipher cipher = Cipher.getInstance(ALGORITHM);<br />
cipher.init(Cipher.DECRYPT_MODE, k);<br />
return cipher.doFinal(data);<br />
}

/**<br />
* DES 算法加密<br />
*<br />
* @param data<br />
* @param key<br />
* @return<br />
* @throws Exception<br />
*/<br />
public static byte[] encrypt(byte[] data, String key) throws Exception {<br />
Key k = toKey(decryptBASE64(key));<br />
Cipher cipher = Cipher.getInstance(ALGORITHM);<br />
cipher.init(Cipher.ENCRYPT_MODE, k);<br />
return cipher.doFinal(data);<br />
}

/**<br />
* DES 算法生成密钥<br />
*<br />
* @return<br />
* @throws Exception<br />
*/<br />
public static String initKey() throws Exception {<br />
return initKey(null);<br />
}

/**<br />
* DES 算法生成密钥<br />
*<br />
* @param seed<br />
* @return<br />
* @throws Exception<br />
*/<br />
public static String initKey(String seed) throws Exception {<br />
SecureRandom secureRandom = null;<br />
if (seed != null) {<br />
secureRandom = new SecureRandom(decryptBASE64(seed));<br />
} else {<br />
secureRandom = new SecureRandom();<br />
}<br />
KeyGenerator kg = KeyGenerator.getInstance(ALGORITHM);<br />
kg.init(secureRandom);<br />
SecretKey secretKey = kg.generateKey();<br />
return encryptBASE64(secretKey.getEncoded());<br />
}

public static void main(String[] args) {<br />
try {<br />
String s = "阿伯才的覆盖";<br />
String b = CryptUtil.encryptBASE64(s.getBytes("UTF-8"));<br />
System.out.println("BASE64加密后:" + b);<br />
byte[] c = CryptUtil.decryptBASE64(b);<br />
System.out.println("BASE64解密后:" + new String(c, "UTF-8"));

c = encryptMD5(s.getBytes());<br />
System.out.println("MD5 加密后:" + new BigInteger(c).toString(16));

c = encryptSHA(s.getBytes());<br />
System.out.println("SHA 加密后:" + new BigInteger(c).toString(16));

String key = initMacKey();<br />
System.out.println("HMAC密匙:" + key);<br />
c = encryptHMAC(s.getBytes(), key);<br />
System.out.println("HMAC 加密后:" + new BigInteger(c).toString(16));

key = initKey();<br />
System.out.println(ALGORITHM + "密钥:\t" + key);<br />
c = encrypt(s.getBytes("UTF-8"), key);<br />
System.out.println(ALGORITHM + " 加密后:" + new BigInteger(c).toString(16));<br />
c = decrypt(c, key);<br />
System.out.println(ALGORITHM + " 解密后:" + new String(c, "UTF-8"));<br />
} catch (UnsupportedEncodingException e) {<br />
// TODO Auto-generated catch block<br />
e.printStackTrace();<br />
} catch (Exception e) {<br />
// TODO Auto-generated catch block<br />
e.printStackTrace();<br />
}<br />
}<br />
}

</pre>
</div>
<pre class="prettyprint linenums">转发 http://www.cnblogs.com/liubin0509/archive/2012/01/29/2331066.html</pre>																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwjg038.html">maven-javaServlet-文件上传</a>
		</li>
						<li><a href="https://www.batexi.com/a/495gvdzq.html">MySQL Doublewrite Buffer及业务评估</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4j530q.html">GCD－两个网络请求同步问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jepge8.html">JavaScript 代码风格指南</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96207yq.html">centos vsftp 服务器配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmmjle9.html">mac 配置jdk maven</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yorz0q.html">Css预处理器实践之Sass、Less大比拼</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmy2m19.html">cnn softmax regression bp求导</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpwzo7q.html">C&num; 笔试题，看你会几道题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gejk7z8.html">用C&plus;&plus;进行简单的文件I&sol;O操作-转自VC知识库</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z0zlk9.html">Vue中之nextTick函数源码分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz4pg48.html">飞思卡尔IMX6处理器的GPIO配置方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyrn6dq.html">Linux&lpar;centos&rpar;系统各个目录的作用详解 推荐</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j120gg9.html">ThreadPoolExecutor 入参 corePoolSize  和 maximumPoolSize 的联系</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4kekk9.html">将 GitHub 上的代码向 Coding 更新</a>
		</li>
						<li><a href="https://www.batexi.com/a/902r2goq.html">解决ajax异步传输数据，return返回为undefined的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vjzm6q.html">python-day7-数字类型的内置方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pkov08.html">推进&amp;quot&semi;五通一平&amp;quot&semi;：手淘技术&amp;quot&semi;三大容器 五大方案&amp;quot&semi;首次整体亮相 百川开放升级</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvemew19.html">Redis 集群方案介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/953kz2z8.html">python操作excel表格文件--使用xlrd模块</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pjnmj79.html">MVC Controller弹窗的几种方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnmdnrq.html">MVC4中给TextBoxFor设置默认值和属性</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okn53l9.html">ubuntu android环境配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gm1dxz9.html">Inside TSQL Querying - Chapter 3&period; Query Tuning</a>
			</li>
						<li><a href="https://www.batexi.com/a/96ojy0y9.html">hibernate笔记02</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k10vm39.html">OpenStack 镜像制作之cloud-init</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0jlo0q.html">解决tomcat占用8080端口问题图文教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1e34m9.html">160905、c3p0详细配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1exjm9.html">WKWebView与Js实战&lpar;OC版&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv57kxq.html">MySQL Replication浅析</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
